<?

  session_start();    // стратуем сессию пользователя для хранения кликов заказов авто
  if(!isset($_SESSION['reserved'])) $_SESSION['reserved'] = array();
  
  
  
  // инфу ниже надо получать из бд
  $mobiles = array(
    "Chevrolet Cruze" => array(
      array(
        "number" => 1,  // id машинки
        "transmission"  =>  "авт.к.п.", // тип переключения
        "reserved"  => array("23.12.11", "26.12.11", "04.01.12")  // занятые даты
      )
    ),
    
    "Ford Fiesta" => array(
      array(
        "number" => 2,
        "transmission"  =>  "мех.к.п.",
        "reserved"  => array("26.12.11", "29.12.11", "06.01.12")      
      )
    ),

    "Ford Focus II" => array(
      array(
        "number" => 3,
        "transmission"  =>  "мех.к.п.",
        "reserved"  => array("24.12.11", "26.12.11")        
      ),
      array(
        "number"  => 4,
        "transmission"  =>  "авт.к.п.",
        "reserved"  => array("22.12.11", "26.12.11")
      )
    ),
    
    "Hundai Accent" => array(
      array(
        "number"  => 6,
        "transmission"  =>  "мех.к.п.",
        "reserved"  => array("23.12.11", "28.12.11", "30.12.11")
      ),
      array(
        "number" => 10,
        "transmission"  =>  "авт.к.п.",
        "reserved"  => array("25.12.11", "26.12.11")
      )
    ),
    
    
    "Kia Ceed" => array(
      array(
        "number" => 15,
        "transmission"  =>  "мех.к.п.",
        "reserved"  => array("25.12.11", "26.12.11")      
      ),
      array(
        "number" => 16,
        "transmission"  =>  "авт.к.п.",
        "reserved"  => array("02.01.12", "03.01.12", "04.01.12", "06.01.12")
      )
    ),
    

    
    "Nissan Almera" => array(
      array(
        "number"  => 19,
        "transmission"  =>  "мех.к.п.",
        "reserved"  => array("25.12.11", "26.12.11")      
      ),
      array(
        "number"  => 20,
        "transmission"  =>  "авт.к.п.",
        "reserved"  => array("06.01.11", "06.01.11", "06.01.11", "06.01.11", "06.01.11")      
      )
    ),
    
    
    "Renault Fluency" => array(
      array(
        "number"  => 25,
        "transmission"  =>  "мех.к.п.",
        "reserved"  => array()      
      ),
      array(
        "number"  => 27,
        "transmission"  =>  "авт.к.п.",
        "reserved"  => array("25.12.11", "26.12.11")
      )
    ),
    
    
    "Renault Logan" => array(
      array(
        "number"  => 30,
        "transmission"  =>  "мех.к.п.",
        "reserved"  => array("28.12.11")
      )
    )
  );
  
  
  // помощнички
  $rus_standart = array(
    "month" => array("January" => "Январь", "February" => "Февраль", "March" => "Март",  "April" => "Апрель", "May" => "Май", "June" => "Июнь", "Jule" => "Июль", "August" => "Август", "September" => "Сентябрь", "October" => "Октябрь", "November" => "Ноябрь", "December" => "Декабрь"),
    "months" => array("", "Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь"),
    "eng_dw" => array("Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun"),
    "rus_dw" => array("пн", "вт", "ср", "чт", "пт", "<b style='color: black;'>сб</b>", "<b style='color: black;'>вс</b>")
  );











// запросы от javascript
if(isset($_POST['op'])){
  
  switch($_POST['op']){
    case "mktable":
      $id_month = date("n") + intval($_POST['month']);
      $year = date("y");
      if($id_month > 12){
        $id_month -= 12; 
        $year++;
      }
      
      die(json_encode(array('month' => $rus_standart['months'][$id_month], "table" => mk_table("календарь", $id_month . "." . $year ))));
      break;
      
    case "setreserv":
    
      // $_POST['number'] - id машинки
      // $_POST['date'] - 21.01.11
      // $_POST['value'] - true(false)
      
      if($_POST['value'] == 'true'){  // добавляем в сессию дату бронирования авто
      
        if(isset($_SESSION['reserved'][$_POST['number']]))
          $_SESSION['reserved'][$_POST['number']][] = $_POST['date'];
        else
          $_SESSION['reserved'][$_POST['number']] = array($_POST['date']);
          
        $output = 'ok';
      
      }else if($_POST['value'] == 'false'){  // удаляем из сессионной переменной дату бронирования авто
        
        foreach((array)$_SESSION['reserved'][$_POST['number']] as $k=>$v){

          if($v == $_POST['date']) unset($_SESSION['reserved'][$_POST['number']][$k]);

        }
        
        $output = verify_order() ? "ok" : "false";
      
      }
      
      die($output);
      break;
      
    case "get-session": // покажем, что всё у нас имеется в сессии что надо
      $output = "<table style='width: 100%;' border='1'>";
      $output .= "<tr><td width='200' align='center' style='padding: 5px;'>ID машинки</td><td align='center'><b>Дата бронирования</b></td></tr>";
      $arr = array();
      foreach($_SESSION['reserved'] as $k=>$v){
        if($v){
          foreach($v as $date){
            $output .= "<tr><td align='center'>{$k}</td><td align='center'>{$date}</td></tr>";
          }
        }
      }
      $output .= "<table>";
      die($output);
      break;
  }
  
}














function verify_order(){  // функция проверяет есть ли отмеченные авто в сессии
  foreach($_SESSION['reserved'] as $k=>$v){
    if($v) return true;
  }
  return false;
}












function mk_table($mode = false, $date = false){
  global $mobiles, $rus_standart;
  
  $output = ""; // буфер для вывода
  
  
  
  
  
  if(!$mode){ // строим список с автомобилями
  
  
  
  
  
    $odd = ' lighter';
    foreach($mobiles as $model => $items){
      $a = 0;
      $model = str_replace(" ", "&nbsp;", $model) . "<span style='font-size: 14px; font-weight: normal;'>...............................</span>";
      foreach($items as $v){
        if($a) $model = "&nbsp;";
        $output .= '<div class="left border-bottom model' . $odd . '">' . $model . '</div><div class="left auto-info border-bottom' . $odd . '">' . $v['transmission'] . '</div><div class="clear"></div>';
        $a++;
      }
      $odd = ($odd) ? '' : ' lighter';
    }
    
    
    
    
    
    
  }else{  // строим таблицу календаря
    
    
    
    
    
    $date = !$date ? explode(".", date("m.y")) : explode(".", $date);
    $now = (date("m") == $date[0] && date("y") == $date[1]) ? date("j") : false;
    $time = mktime(0, 0, 0, $date[0], 1, $date[1]);
    $days_month = date("t", $time);
    
    $output = "<table class='order-days'>";
    $output .= mk_table_row("order-today-row", $days_month, $now); // лайба для "сегодня"
    $output .= mk_table_row("order-table-row", $days_month, $now); // числа месяца

    // дни недели
    $dw_start = date("D", $time);
    foreach($rus_standart['eng_dw'] as $dw_key=>$v){
      if($dw_start == $v) break;
    }
    // #fec51c; url(/sources/images/order-table-sprite.png) no-repeat 2px -181px
    $output .= "<tr class='order-table-dw'>"; 
    for($d = 1; $d <= $days_month; $d++){
      if($dw_key > 6) $dw_key = 0; 
      $output .= "<td" . ($now == $d ? " style='background-position: 2px -217px;'" : "" ) . ">" . $rus_standart['rus_dw'][$dw_key] . "</td>";
      $dw_key++;
    }        
    $output .= "</tr>" . mk_table_row("null-padding", $days_month, $now); // лайба отсутпа
    
    
    
    // чекбоксы
    $odd = ' lighter';
    foreach($mobiles as $model => $items){
      foreach($items as $v){
        $output .= "<tr class='order-fixed{$odd}'>";

          for($d = 1; $d <= $days_month; $d++){
            $date_normal = ($d < 10 ? "0" . $d : $d) . "." . ($date[0] < 10 ? "0" . $date[0] : $date[0]) . "." . $date[1];
            $checked = '';
            $disabled = $d < $now ? "disabled" : '';
            foreach($v['reserved'] as $r){  // это если реально тачки забиты на этот день из бд
              if($date_normal == $r){
                $checked = 'checked';
                $disabled = 'disabled';
              }
            }
            
            if(empty($disabled) and isset($_SESSION['reserved'][$v['number']])){ // метки заказов чела из сессии
              foreach((array)$_SESSION['reserved'][$v['number']] as $_date){
                if($date_normal == $_date){
                  $checked = 'checked';
                }                
              }
            }
            
            $output .= "<td" . ($now == $d ? " style='background: url(/sources/images/order-table-sprite.png) no-repeat 2px -257px;" . ($odd ? " background-position: 2px -217px;" : "") . "'" : "" ) . "><input type='checkbox' name='chk' rel='{$v['number']}' value='{$date_normal}' {$disabled} {$checked} /></td>";
          }

        $output .= "<tr>";
      }
        
      $odd = ($odd) ? '' : ' lighter';
      
    }
      
    $output .= "</table>";
  
  }
  
  return $output;
}




// формирует три похожие строки в таблице календаря заказа
function mk_table_row($class, $days_month, $now){

  $output = "<tr class='{$class}'>";
  for($d = 1; $d <= $days_month; $d++){ 
    $output .= "<td";
    if($class == "order-today-row"){
      $output_temp = ($now == $d ? "Сегодня<br /><img id='today-arrow-id' src='/sources/images/arrow-today-down.png' alt=''>" : "&nbsp;");
    }else if($class == "order-table-row"){
      $output .= ($now == $d ? " style='background-position: 2px -199px;'" : "");
      $output_temp = $d < 10 ? "0" . $d : $d;
    }else if($class == "null-padding"){
      $output .= ($now == $d ? " style='background: url(/sources/images/order-table-sprite.png) no-repeat 2px -258px;'" : "" );
      $output_temp = "";
    }
    $output .= ">" . $output_temp . "</td>";
  }
  $output .= "</tr>";
  return $output;
}
